import math
import struct
import datatypes
import random

def print_float(sgn, exp, mantissa):
    return (1-2*sgn)*2**(exp-127)*(1+mantissa/2**23)

def get_float(val):
    return struct.unpack('I', struct.pack('f', val))[0]

def get_fixed(val):
    return datatypes.fp(val)


def get_float_div_test(count):
    string = ""
    for c in range(0, count):
        a = random.uniform(-10, 10)
        b = random.uniform(-10, 10)

        print('a: ({}, {:08x}); b: ({}, {:08x}) a/b: ({}, {:08x})'.format(
            a, get_float(a), b, get_float(b), a/b, get_float(a/b)
        ))

        string += '{:08x} {:08x} {:08x}\n'.format(get_float(a), get_float(b), get_float(a/b))

    file = open('float_div_setup.hex', 'w+')
    file.write(string)
    file.close()
