package types;
    typedef logic [31:0] float32;
    typedef logic [31:0] fixed32;
    typedef logic [95:0] vec3_pack_t;

    typedef struct packed {
        fixed32 x;
        fixed32 y;
        fixed32 z;
    } vec3_t;

    typedef struct packed {
        vec3_pack_t     orig;
        vec3_pack_t     dir;
        logic [31:0]    addr;
        logic [31:0]    job_id;
    } ray_t;

    typedef struct packed {
        logic [2:0]     a;
        vec3_pack_t     t0;
        vec3_pack_t     t1;
        logic [31:0]    addr;
        logic [31:0]    job_id;
    } job_t;

    typedef struct packed {
        logic        hit;
        fixed32      t_hit;
        vec3_pack_t  normal;
        logic [31:0] cost;
        logic [31:0] job_id;
    } result_t;
endpackage
