module scheduler #(
    parameter CORE_CNT = 32
) (
    input  logic clk,
    input  logic reset,

    output logic in_ready,
    input  logic in_valid,

    input  logic [CORE_CNT-1:0] core_ready,
    output logic [CORE_CNT-1:0] core_valid
);

logic [$clog2(CORE_CNT)-1:0] core_select;

assign in_ready = core_ready[core_select];
assign core_valid = in_valid << core_select;

always @(posedge clk) begin
    if (reset == 'b1) begin
        core_select <= 'b0;
    end else begin
        core_select <= 'b0;

        if (core_select < CORE_CNT - 1) begin
            core_select <= core_select + 1;
        end
    end
end
endmodule
